CONTENTS OF THIS FILE
---------------------

 * Introduction
 * Requirements
 * Installation
 * Configuration
 * Troubleshooting
 * Maintainers


INTRODUCTION
------------

This module provides integration with the MeiliSearch service
(https://www.meilisearch.com/), which is a powerful, fast, open-source, easy to
use, and deploy search engine. It serves as a back-end to an existing Search
API module that provides the interface for the search functionality.

Currently supports:
 * Creating and deleting indexes on the MeiliSearch server.
 * Indexing of selected entities.


REQUIREMENTS
------------

This module requires the following modules:

 * Search API (https://www.drupal.org/project/search_api)

VERSIONS COMPATIBILITY
----------------------

| Search API Meilisearch | meilisearch-php | Meilisearch |
|------------------------|-----------------|-------------|
| 1.0.0                  | 0.10.2          | 0.10.0      |
| 1.0.x-dev              | 0.24.0          | 0.28.0      |

INSTALLATION
------------

 * Install as you would normally install a contributed Drupal module. Visit
   https://www.drupal.org/node/1897420 for further information.

 * First you need to set up the MeiliSearch server. For that, you can follow the
   instructions on
   (https://docs.meilisearch.com/guides/introduction/quick_start_guide.html)


CONFIGURATION
-------------

    1. Navigate to /admin/config/search/search-api and create a server with
       MeiliSearch as a backend.

    2. In the MeiliSearch backend config form enter the host address and host
       port.

    3. If you added the master key to the MeiliSearch server, the private key
       was generated automatically. Paste it into the configuration form. If no
       master key was set, this field can be left empty.


TROUBLESHOOTING
---------------

 * The main difference between Drupal entities and indexed documents is the
format of ids. The MeiliSearch specifies that the id should not contain any
other character than A-Z, a-z, 0-9 and -_. Because the format of an id in
Drupal consists of : and / characters it needs to be prepared accordingly.
So to make sure MeiliSearch accepts documents the drupal id gets stripped of all
:, / characters and replaced with underscores. So the entity:node/1:en becomes
entity_node_1_en. The mapping of all indexed ids from Drupal format to
MeiliSearch format gets saved in the configuration of this module. This is
necessary because when we search the index, the results ids should be
converted back to Drupal format.

 * The next thing to take into consideration is the format of the documents
that are sent to the server. The documents need to be sent as an array of
arrays that contains at least one key containing the word id (case-insensitive).

Example:
```php
$documents = [
    [
      'book_id' => 123,
      'title' => 'Pride and Prejudice',
      'author' => 'Jane Austen'
    ],
    [
      'book_id' => 456,
      'title' => 'Le Petit Prince',
      'author' => 'Antoine de Saint-Exupéry'
    ],
    ...
];
```
For more information about the API, you can visit https://docs.meilisearch.com


MAINTAINERS
----------

Supporting organizations:
 * Agiledrop - https://www.drupal.org/agiledrop
