<?php

namespace Drupal\Tests\search_api_meilisearch\Traits\Api;

use Drupal\search_api_meilisearch\Api\MeiliSearchApiServiceInterface;

/**
 * Trait provides creation of new documents.
 */
trait DocumentsCreationTrait {

  /**
   * Creates documents on a given index.
   *
   * @param string $indexName
   *   The name of the index.
   * @param array $documents
   *   A list of documents.
   * @param \Drupal\search_api_meilisearch\Api\MeiliSearchApiServiceInterface $apiService
   *   The api service.
   */
  public function createDocuments(string $indexName, array $documents, MeiliSearchApiServiceInterface $apiService): void {
    $task = $apiService->addDocuments($indexName, $documents);
    $apiService->connection()->waitForTask($task['taskUid']);
  }

}
