<?php

namespace Drupal\Tests\search_api_meilisearch\Traits\Api;

use Drupal\search_api_meilisearch\Api\MeiliSearchApiServiceInterface;

/**
 * Trait provides creation of a new index.
 */
trait IndexCreationTrait {

  /**
   * Creates a new index.
   *
   * @param string $name
   *   The index name.
   * @param \Drupal\search_api_meilisearch\Api\MeiliSearchApiServiceInterface $apiService
   *   The meilisearch api service.
   */
  public function createIndex(string $name, MeiliSearchApiServiceInterface $apiService): void {
    $task = $apiService->createIndex($name);
    $apiService->connection()->waitForTask($task['taskUid']);
  }

}
