<?php

namespace Drupal\Tests\search_api_meilisearch\Traits\Api;

use Drupal\search_api_meilisearch\Api\MeiliSearchApiServiceInterface;

/**
 * Trait for creating api service in tests.
 */
trait ServiceCreationTrait {

  /**
   * Creates the api service with url and master key set.
   *
   * Default host, port and master key are set as in drupal ci but can be
   * overriden with env variables for other environments.
   */
  public function getInstance(): MeiliSearchApiServiceInterface {
    $host = getenv('MEILI_TEST_HOST') ?: 'http://meilisearch';
    $port = getenv('MEILI_TEST_PORT') ?: '7700';
    $masterKey = getenv('MEILI_TEST_MASTER_KEY') ?: 'MASTER_KEY';

    /** @var \Drupal\search_api_meilisearch\Api\MeiliSearchApiServiceInterface $service */
    $service = \Drupal::service('search_api_meilisearch.api');
    $service->setUrl($host . ':' . $port);
    $service->setMasterKey($masterKey);

    return $service;
  }

}
